<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">

<xsl:output 
   method="xml" encoding="UTF-8" 
   media-type="text/xml" 
   doctype-public="-//W3C//DTD XHTML 1.1//EN" 
   doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"
   indent="yes" />

<!-- ROOT -->
<xsl:template match="/">
<xsl:element name="html">
  <xsl:attribute name="lang"
            namespace="http://www.w3.org/XML/1998/namespace">ja</xsl:attribute>
<xsl:call-template name="head" />
<!-- Body -->
<xsl:element name="body">
<!-- Navi-->
<xsl:call-template name="navi" />

<h1>Searched Result Count: <xsl:value-of select="count(archives/entries/entry)" /> </h1>

<!-- Contents -->
<xsl:apply-templates select="archives/entries/entry" />

</xsl:element>
</xsl:element>
</xsl:template>

<!-- Templates Items -->
<xsl:template match="archives/entries/entry">
<xsl:element name="div">
<xsl:element name="dl">

<xsl:element name="dt">
	<xsl:element name="a">
		<xsl:attribute name="href"><xsl:value-of select="uri" /></xsl:attribute><xsl:value-of select="subject" disable-output-escaping="yes"/>
	</xsl:element>
</xsl:element>

<xsl:element name="dd">Posted By: &#8220;<xsl:value-of select="name" disable-output-escaping="yes" />&#8221;&#8194;at&#8194; <xsl:value-of select="date" /></xsl:element>    
<xsl:element name="dd">Posted ID: &#8194;<xsl:value-of select="t_i" /></xsl:element>
<xsl:element name="dd">Comment : &#8194;(<xsl:value-of select="itemcount" />)</xsl:element>
	
	<xsl:apply-templates select="item_comment" />

</xsl:element><!-- end dl -->
</xsl:element><!-- end div -->
</xsl:template>


<!-- Templates item_comment -->
<xsl:template match="item_comment">
<xsl:element name="dd">
	<xsl:apply-templates select="postno" />
	<xsl:apply-templates select="name" disable-output-escaping="yes"/><br />
	<xsl:apply-templates select="p" />
</xsl:element>
</xsl:template>

<xsl:template match="postno">#<xsl:value-of select="." />.</xsl:template>
<xsl:template match="name">PostedBy:&#8220;<xsl:value-of select="." disable-output-escaping="yes"/>&#8221;</xsl:template>
<xsl:template match="p"><xsl:text>&#8195;&#8195;</xsl:text><xsl:value-of select="." />...</xsl:template>


<!-- HEADER -->
<xsl:template name="head">
  <xsl:element name="head">
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <meta name="author" content="midore"/>
    <!-- meta name="date" -->
    <xsl:element name="meta">
      <xsl:attribute name="name">date</xsl:attribute>
        <xsl:attribute name="content"><xsl:value-of select="archives/metadate" /></xsl:attribute>
    </xsl:element>
    <!-- rel="stylesheet" -->
    <xsl:element name="link">
      <xsl:attribute name="rel">stylesheet</xsl:attribute>
      <xsl:attribute name="type">text/css</xsl:attribute>
      <xsl:attribute name="media">screen,tv</xsl:attribute>
      <xsl:attribute name="href">/css/daybook_index.css</xsl:attribute>
      <xsl:attribute name="title">daybook.css</xsl:attribute>
    </xsl:element>

    <!-- title -->
    <xsl:element name="title">searched</xsl:element>
  </xsl:element>
</xsl:template>

<!-- Navi  -->
<xsl:template name="navi">
<xsl:element name="h1">
	<xsl:element name="a"><xsl:attribute name="href">http://www.midore.net</xsl:attribute>www.midore net</xsl:element> ::
  <xsl:element name="a"><xsl:attribute name="href">/daybook/daybook_index.html</xsl:attribute>Daybook Index</xsl:element> ::
  <xsl:element name="a"><xsl:attribute name="href">/daybook/daybook_archives.html</xsl:attribute>Daybook Archives</xsl:element>
</xsl:element>
</xsl:template>



<!-- END -->
</xsl:stylesheet>